<?php
/*
Plugin Name: Поиск по дополнительным полям WordPress
Plugin URI: http://rusvc.ru
Description: Ищет текст по пользовательским дополнительным полям (custom fields)
Version: 1.0
Author: RusVC
Author URI: http://ivbutusov.ru
*/

add_action('admin_menu', 'rusvc_cf_filter_menu');

function rusvc_cf_filter_menu() {
	$h_chan = add_posts_page('Поиск по дополнительным полям', 'Поиск по дополнительным полям', 'edit_posts', 'rusvc-cf-filter', 'rusvc_cf_filter_page');
}

function rusvc_cf_filter_page() {
    
global $wpdb, $id, $authordata, $currentday, $currentmonth, $page, $pages, $post, $multipage, $more, $numpages;
    
if(isset($_GET['sq'])) $sq = urldecode($_GET['sq']);
else $sq = '';
if(isset($_GET['meta-key'])) $meta_key = urldecode($_GET['meta-key']);
else $meta_key = '';
    
?>
<div class="wrap"><h2><?php _e('Поиск по дополнительным полям'); ?></h2>

<form action="" method="get">
<p class="search-box" style="margin-bottom: 1em;"><input type="search" name="sq" placeholder="Поиск" value="<?=$sq?>" />
<select name="meta-key" style="margin-top: -2px;">
<option selected value="" <?php if($meta_key == '') echo 'selected'; ?>>Выберите поле</option>
<?php
    $meta_keys = $wpdb->get_col('SELECT DISTINCT meta_key FROM ' . $wpdb->postmeta . ' ORDER BY meta_key');
    if($meta_keys) {
        foreach ($meta_keys as $key) {
            $sel = '';
            if($key == $meta_key) $sel = 'selected';
            echo '<option value="' . $key . '" ' . $sel . '>' . $key . '</option>';
        }
    }
?>
</select>
<input type="submit" name="filter" value="Найти" class="button action subx" /></p>
<input type="hidden" name="page" value="rusvc-cf-filter" />
</form>

<table class="wp-list-table widefat fixed" cellspacing="0">
	<thead><th>Результаты поиска</th></thead>
	<tbody>
	<?php
	    if($meta_key != '' && $sq != '') {
	        $q = get_posts(array(
	            'post_type' => 'post',
	            'posts_per_page' => -1,
	            'meta_query' => array(
		            array(
		               'key'     => $meta_key,
		               'value'   => $sq,
		               'compare' => 'LIKE'
		            )
	            )
            ));
            //print_r($q);
            foreach( $q as $post ){
		        setup_postdata($post);
		        echo '<tr><td>';
		        echo '<a href="'. admin_url() .'post.php?post=' . $post->ID . '&action=edit" rel="noopener" target="_blank">'. get_the_title() .'</a> (' . get_the_time('j.m.Y H:i') . ')';
		        echo '</td></tr>' . "\n";
		        wp_reset_postdata();
	        }
	    }
	?>
    </tbody>
</table>
<?php }

?>